#
# Conditional build:
%bcond_without	ocaml_opt	# native optimized binaries (bytecode is always built)

# not yet available on x32 (ocaml 4.02.1), update when upstream will support it
%ifnarch %{ix86} %{x8664} %{arm} aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

%define debug_package %{nil}

Summary:	OCaml Curl library (ocurl)
Summary(pl.UTF-8):	Biblioteka Curl dla OCamla (ocurl)
Name:		ocaml-curl
Version:	0.9.1
Release:	5
License:	MIT
Group:		Libraries
#Source0Download: https://github.com/ygrek/ocurl/releases
Source0:	https://github.com/ygrek/ocurl/releases/download/%{version}/ocurl-%{version}.tar.gz
# Source0-md5:	1ff6b12803fa0c6e9a4358dd29b83910
Patch0:		ocaml_opt.patch
Patch1:		%{name}-sh.patch
URL:		https://ygrek.org/p/ocurl/
BuildRequires:	autoconf >= 2.50
BuildRequires:	curl-devel >= 7.28.0
BuildRequires:	gawk
BuildRequires:	ocaml >= 3.10.0-7
BuildRequires:	ocaml-findlib-devel
BuildRequires:	ocaml-lwt-devel
BuildRequires:	ocaml-lwt-ppx-devel
BuildRequires:	pkgconfig
# Explicitly require Curl (fixes RHBZ#711261). Since ocaml-curl uses
# -custom rather than ocamlmklib, automatic detection is infeasible.
Requires:	curl-devel >= 7.28.0
%requires_eq	ocaml-runtime
ExcludeArch:	sparc64 s390 s390x
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Ocaml Curl Library (Ocurl) is an interface library for the
programming language Ocaml to the networking library libcurl.

%description -l pl.UTF-8
Biblioteka Ocaml Curl (Ocurl) to biblioteka interfejsu języka
programowania Ocaml do biblioteki sieciowe libcurl.

%package devel
Summary:	OCaml Curl library (ocurl) - development part
Summary(pl.UTF-8):	Biblioteka Curl dla OCamla (ocurl) - część programistyczna
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
This package contains libraries and signature files for developing
applications that use OCaml Curl library.

%description devel -l pl.UTF-8
Ten pakiet zawiera biblioteki i pliki sygnatur do tworzenia aplikacji
z użyciem biblioteki OCamla Curl.

%package lwt
Summary:	Lwt support for OCaml Curl library
Summary(pl.UTF-8):	Obsługa Lwt do biblioteki OCamla Curl
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	ocaml-lwt

%description lwt
Lwt support for OCaml Curl library.

%description lwt -l pl.UTF-8
Obsługa Lwt do biblioteki OCamla Curl.

%package lwt-devel
Summary:	Lwt support for OCaml Curl library - development part
Summary(pl.UTF-8):	Obsługa Lwt do biblioteki OCamla Curl - część programistyczna
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-lwt = %{version}-%{release}
Requires:	ocaml-lwt-devel

%description lwt-devel
This package contains libraries and signature files for developing
applications that use OCaml curl-lwt library.

%description lwt-devel -l pl.UTF-8
Ten pakiet zawiera biblioteki i pliki sygnatur do tworzenia aplikacji
z użyciem biblioteki OCamla curl-lwt.

%prep
%setup -q -n ocurl-%{version}
%patch0 -p1
%patch1 -p1

%build
%{__autoconf}
%configure
%{__make} -j1 all

%install
rm -rf $RPM_BUILD_ROOT

export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml
install -d $OCAMLFIND_DESTDIR $OCAMLFIND_DESTDIR/stublibs

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# useless in rpm
%{__rm} $RPM_BUILD_ROOT%{_libdir}/ocaml/stublibs/*.so.owner

# Make clean in the examples dir so our docs don't contain binaries.
%{__make} -C examples clean
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -p examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc COPYING
%dir %{_libdir}/ocaml/curl
%{_libdir}/ocaml/curl/META
%{_libdir}/ocaml/curl/curl.cma
%if %{with ocaml_opt}
%attr(755,root,root) %{_libdir}/ocaml/curl/curl.cmxs
%endif
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllcurl-helper.so

%files devel
%defattr(644,root,root,755)
%{_libdir}/ocaml/curl/libcurl-helper.a
%{_libdir}/ocaml/curl/curl.cmi
%{_libdir}/ocaml/curl/curl.cmt
%{_libdir}/ocaml/curl/curl.cmti
%{_libdir}/ocaml/curl/curl.mli
%if %{with ocaml_opt}
%{_libdir}/ocaml/curl/curl.a
%{_libdir}/ocaml/curl/curl.cmx
%{_libdir}/ocaml/curl/curl.cmxa
%endif
%{_examplesdir}/%{name}-%{version}

%files lwt
%defattr(644,root,root,755)
# without ocaml_opt: just stub package to collect dependencies
%if %{with ocaml_opt}
%attr(755,root,root) %{_libdir}/ocaml/curl/curl_lwt.cmxs
%endif

%files lwt-devel
%defattr(644,root,root,755)
%{_libdir}/ocaml/curl/curl_lwt.cmi
%{_libdir}/ocaml/curl/curl_lwt.cmo
%{_libdir}/ocaml/curl/curl_lwt.cmt
%{_libdir}/ocaml/curl/curl_lwt.cmti
%{_libdir}/ocaml/curl/curl_lwt.mli
%if %{with ocaml_opt}
%{_libdir}/ocaml/curl/curl_lwt.cmx
%{_libdir}/ocaml/curl/curl_lwt.o
%endif
%changelog
* Mon Dec 27 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-curl.git;a=log;h=master

* Sat Dec 25 2021 Jakub Bogusz <qboosh@pld-linux.org> 44adc8b
- updated URL, release 5

* Sat Dec 25 2021 Jakub Bogusz <qboosh@pld-linux.org> 2da40ed
- use upstream provided META file, separated -lwt* subpackages (supported via exists-if in META)

* Sat Dec 25 2021 Jakub Bogusz <qboosh@pld-linux.org> d7e8373
- no need to (re)install .mli file

* Sat Dec 25 2021 Jakub Bogusz <qboosh@pld-linux.org> aa52189
- moved examples to examplesdir

* Sat Dec 25 2021 Jakub Bogusz <qboosh@pld-linux.org> 6131789
- added sh patch (remove bashism from configure), unified ocaml files packaging

* Thu Dec 23 2021 Jakub Bogusz <qboosh@pld-linux.org> 0acf091
- pl

* Mon Nov 22 2021 Jan Rękorajski <baggins@pld-linux.org> 0680142
- updated BRs and opt patch, rel 4

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 75901a6
- rebuild with separate debuginfo build-ids

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> 90c843a
- fix non-opt files

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> a1673ef
- cleanup files
- rel 2

* Wed Mar 24 2021 Jan Rękorajski <baggins@pld-linux.org> 9ed0416
- updated opt patch
- install META where dune expects it

* Wed Mar 24 2021 Jan Rękorajski <baggins@pld-linux.org> e88cf73
- up to 0.9.1

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> 10d7111
- rebuild with ocaml 4.04.1
- release 5 (by relup.sh)

* Fri Mar 18 2016 Jan Rękorajski <baggins@pld-linux.org> a53b4f3
- release 4 (by relup.sh)

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> a82d6b2
- release 3 (by relup.sh)

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> 5750614
- cleaned up ocaml_opt bcond usage

* Sat Jul 25 2015 Jan Rękorajski <baggins@pld-linux.org> 9781d07
- fix install without ocaml opt build

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> c63f57e
- strict ocaml deps
- rel 2

* Sat Aug 30 2014 Jan Rękorajski <baggins@pld-linux.org> 8fd8b94
- up to 0.7.1

* Mon Feb 17 2014 Jan Rękorajski <baggins@pld-linux.org> d878cf6
- fix source url and md5sum

